local APH = LibStub("AceAddon-3.0"):NewAddon("APH", "AceConsole-3.0", "AceEvent-3.0")
local _,APHdata = ...



local AceGUI = LibStub("AceGUI-3.0")
local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local AceConfigRegistry = LibStub("AceConfigRegistry-3.0")

local _G = getfenv(0)

local APHMainFrame
local APHInfoFrame
local ArtPow = {}
local TotalArtifactPower = 0
local APHArtifactItems = {}

local _,class= UnitClass("PLAYER")



local msq, msqGroups = nil, {}
if LibStub then
	msq = LibStub("Masque",true)
	if msq then
		msqGroups = {
			APHItems = msq:Group("Artifact Power Helper", "Items"),
			APHWeapons = msq:Group("Artifact Power Helper", "Weapons"),
		}
	end
end

local defaults = {
    profile = {
		MainPosX = UIParent:GetWidth() / 2,
		MainPosY = UIParent:GetHeight() / 2,

    },
}




function APH:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("APHDB", defaults, true)
    --LibStub("AceConfig-3.0"):RegisterOptionsTable("ArtifactPowerHelper", options)
	--self:UpdateOptions()
	--self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("ArtifactPowerHelper", "Artifact Power Helper")

	
	APH.PosX = self.db.profile.MainPosX
	APH.PosY = self.db.profile.MainPosY
	APH:Print(APH.PosX, APH.PosY)
	APHMainFrame:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",APH.PosX,APH.PosY)
	APH:RegisterEvent("PLAYER_REGEN_DISABLED")
	APH:RegisterEvent("PLAYER_REGEN_ENABLED")
	--APH:RegisterEvent("ZONE_CHANGED")
	--APH:RegisterEvent("ZONE_CHANGED_INDOORS")
	--APH:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	--APH:RegisterEvent("UNIT_AURA")
	APH:RegisterEvent("BAG_UPDATE")
	APH:RegisterEvent("PLAYER_ENTERING_WORLD")
	APH:RegisterEvent("ARTIFACT_UPDATE")
	APH:RegisterChatCommand("aph", "Test")
	APH:RegisterChatCommand("aphh","Hide")
	
end


 
function APH:Hide()
APHMainFrame:Hide()
end


function APH:Test()
	--APH:UpdateWeapons()
	--APH:GetInventoryItems()
	--APH:Print("Total gains:",TotalArtifactPower)
	--APH:Print("Done!")

--local frame = AceGUI:Create("Frame")
--frame:SetTitle("Example Frame")
--frame:SetStatusText("AceGUI-3.0 Example Container Frame")
--frame:SetCallback("OnClose", function(widget) AceGUI:Release(widget) end)
--frame:SetLayout("Flow")

--local editbox = AceGUI:Create("EditBox")
--editbox:SetLabel("Insert text:")
--editbox:SetWidth(200)
--frame:AddChild(editbox)

--local button = AceGUI:Create("Button")
--button:SetText("Click Me!")
--button:SetWidth(200)
--frame:AddChild(button) 		
	for i,a in ipairs(C_ArtifactUI.GetPowers()) do
		APH:Print(i,a)
	end
	APH:Print(C_ArtifactUI.GetEquippedArtifactInfo())
end

function APH:HideTT()
	GameTooltip_Hide()
end
function APH:ShowTT(id)
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent)
	GameTooltip:SetItemByID(id)
	GameTooltip:Show()
end

function table.contains(table, element,index)
  for i, value in pairs(table) do
    if value[index] == element then
      return i
    end
  end
  return false
end

local function ReadableNumber(num, places)
    local ret
    local placeValue = ("%%.%df"):format(places or 0)
    if not num then
        return 0
    elseif num >= 1000000000000 then
        ret = placeValue:format(num / 1000000000000) .. " T" -- trillion
    elseif num >= 1000000000 then
        ret = placeValue:format(num / 1000000000) .. " B" -- billion
    elseif num >= 1000000 then
        ret = placeValue:format(num / 1000000) .. " M" -- million
    elseif num >= 1000 then
        ret = placeValue:format(num / 1000) .. "K" -- thousand
    else
        ret = num -- hundreds
    end
    return ret
end


function APH:FindItemInBags(ItemID)
	local NumSlots
	for Container = 0, NUM_BAG_SLOTS do
		NumSlots = GetContainerNumSlots(Container)
		if NumSlots then
			for Slot = 1, NumSlots do
				if ItemID == GetContainerItemID(Container, Slot) then
					return Container, Slot
				end
			end
		end
	end
	return false
end

function APH:GetInventoryItems()
	TotalArtifactPower=0
	for bag = 0, NUM_BAG_SLOTS do
        for slot = 1, GetContainerNumSlots(bag) do
			id = GetContainerItemID(bag, slot)
			a,b = GetItemSpell(GetContainerItemLink(bag, slot))
			if a=="Empowering" then
				--APH:Print(a,b,id)
				--local tmp={}
				--ArtPow[index]={id,ap,count}
				--tmp = {id, APH:ReadAP(id) or 0
				newItemAP=APH:ReadAP(id) or 0
				conf=table.contains(ArtPow,id,1)
				if conf then
					if newItemAP == ArtPow[conf][2] then
						ArtPow[conf][3]=ArtPow[conf][3]+1
					else
						--
					end
				else
				--APH:Print(id, newItemAP)
					tinsert(ArtPow,{id,newItemAP,1})
				end
				--tinsert(ArtPow,tmp)
				TotalArtifactPower = TotalArtifactPower + newItemAP
			end
        end
    end
	--APH:Print(ArtPow)
	sort(ArtPow,function(a,b) return a[2]>b[2] end)
	for _, apw in ipairs(ArtPow) do
		--APH:Print(apw)
	end
	
end

function APH:CreateArtifactItems()
	for i=1, 21, 1 do
		local items = CreateFrame("Button","ArtPowerItem"..i,ArtifactPowerFrame,"SecureActionButtonTemplate")
			items:SetPushedTexture([[Interface\Buttons\UI-Quickslot-Depress]])
			items:SetHighlightTexture([[Interface\Buttons\ButtonHilight-Square]],"ADD")

			--items:SetSize(36,36)
			items:SetHeight(32)
			items:SetWidth(32)
			items.Icon=items:CreateTexture(nil,"BACKGROUND")
			--texture=select(10, GetItemInfo(id))
			items.Icon:SetAllPoints(items)
			--items.Icon:SetTexture(texture)
			--items:SetPoint("TOPLEFT",ArtifactPowerFrame,"TOPLEFT", (i-1)*36, 0)
			
			--items:SetScript("OnEnter", function() APH:ShowTT(id) end)
			--items:SetScript("OnLeave", function() APH:HideTT() end)
			items.Count = items:CreateFontString("Count"..i,"ARTWORK","NumberFontNormal")
			items.Count:SetJustifyH("RIGHT")
			items.Count:SetPoint("BottomRight",-2,2)

			items.AP = items:CreateFontString("AP"..i,"ARTWORK","NumberFontNormal")
			items.AP:SetJustifyH("LEFT")
			items.AP:SetPoint("TOPLEFT")
			
			items:RegisterForClicks("AnyUp")
			items:SetAttribute("type","item")
			
			if msqGroups["APHItems"] then msqGroups.APHItems:AddButton(items) end

		tinsert(APHArtifactItems,items)
	end	
	return APHArtifactItems
end

local Weapons = {}
function APH:CreateWeaponsIcons()
	for ct,weapon in ipairs(APHdata.ArtifactWeapons[class]) do
		local WeaponIcon=CreateFrame("Button","ArtifactWeapon"..ct,ArtifactInfoFrame,"SecureActionButtonTemplate")
			WeaponIcon:SetSize(40,40)
			WeaponIcon:SetPushedTexture([[Interface\Buttons\UI-Quickslot-Depress]])
			WeaponIcon:SetHighlightTexture([[Interface\Buttons\ButtonHilight-Square]],"ADD")
			--WeaponIcon:SetButtonState("PUSHED",true)
			--if C_ArtifactUI.GetEquippedArtifactInfo()==weapon then ActionButton_ShowOverlayGlow(WeaponIcon) end
			--local icon= select(10,GetItemInfo(weapon))
			WeaponIcon.Icon=WeaponIcon:CreateTexture(nil, "BACKGROUND")
			--WeaponIcon.Icon:SetTexture(icon)
			WeaponIcon.Icon:SetAllPoints(WeaponIcon)
			--WeaponIcon:SetPoint("TOPLEFT",ArtifactInfoFrame,"TOPLEFT",60*ct,0)
			--WeaponIcon:SetScript("OnEnter", function() APH:ShowTT(weapon) end)
			--WeaponIcon:SetScript("OnLeave", function() APH:HideTT() end)
			WeaponIcon.Percent = WeaponIcon:CreateFontString("Percent","ARTWORK","NumberFontNormal")
			WeaponIcon.Percent:SetFont("Fonts\\FRIZQT__.TTF", 14, "THICKOUTLINE")
			WeaponIcon.Percent:SetJustifyH("CENTER")
			WeaponIcon.Percent:SetJustifyV("MIDDLE")
			WeaponIcon.Percent:SetPoint("CENTER",2,0)

			tinsert(Weapons,WeaponIcon)
			if msqGroups["APHWeapons"] then msqGroups.APHWeapons:AddButton(WeaponIcon) end
	end
end



local tip = CreateFrame ("GameTooltip", "APHTooltipReader", nil, "GameTooltipTemplate")
local tipTextLeft1 = _G ["APHTooltipReaderTextLeft2"]
local tipTextLeft2 = _G ["APHTooltipReaderTextLeft3"]
local tipTextLeft3 = _G ["APHTooltipReaderTextLeft4"]
local tipTextLeft4 = _G ["APHTooltipReaderTextLeft5"]
function APH:ReadAP (itemLink)
	tip:SetOwner (WorldFrame, "ANCHOR_NONE")
	tip:SetItemByID (itemLink)
	
	local text = tipTextLeft1:GetText()
	if (text and text:match ("|cFFE6CC80")) then
		local power = tipTextLeft3:GetText()
		if (power) then
			power = power:gsub ("%p", ""):match ("%d+")
			power = tonumber (power)
			return power or 0
		end
	end
	
	local text2 = tipTextLeft2:GetText() --thanks @Prejudice182 on curseforge
	if (text2 and text2:match ("|cFFE6CC80")) then
		local power = tipTextLeft4:GetText()
		if (power) then
			power = power:gsub ("%p", ""):match ("%d+")
			power = tonumber (power)
			return power or 0
		end
	end
end

local function CalcPercent(rank,totalAP)
if not rank or rank == nil then return 0 end
if not totalAP or totalAP == nil then return 0 end
	local ret, ranksGained = _,0
	local cost = APHdata.ArtifactCosts[rank]
	local InitialRank=rank
	if(cost < totalAP) then
		repeat
			rank = rank + 1
			newCost=APHdata.ArtifactCosts[rank]
			totalAP = totalAP - cost
			cost = newCost
		until cost > totalAP or rank > 34
		ranksGained = rank - InitialRank
	end
	ret = totalAP/cost


	return math.floor( (ret + ranksGained)*100)
end

local CostOfNext, CurPow, Equipped, CurRank

function APH:UpdateWeapons()
	local UnlockedWeapons = {}
	Equipped,_,_,_,CurPow, CurRank = C_ArtifactUI.GetEquippedArtifactInfo()
	CurPow, CurRank = CurPow or 0, CurRank or 0
	CostOfNext = C_ArtifactUI.GetCostForPointAtRank(CurRank or 0)
	--APH:Print(CurPow, CurRank, CostOfNext)
	tinsert(UnlockedWeapons,Equipped)
	--APH:Print(Equipped)
	for _,weapon in ipairs(APHdata.ArtifactWeapons[class]) do
		if APH:FindItemInBags(weapon) then
			tinsert(UnlockedWeapons,weapon)
		end
	end
	--APH:Print("Number of unlocked",#UnlockedWeapons)
	local nW = #UnlockedWeapons
	--APH:Print(APHdata.WC[nW].OffSet,APHdata.WC[nW].Spacing)
	for i, j in ipairs(UnlockedWeapons) do
		local weap = Weapons[i]
		texture = select(10, GetItemInfo(j) )
		weap.Icon:SetTexture(texture)
		if i==1 then -- Equipped Weapon
			local Percent = CalcPercent(CurRank +1, CurPow + TotalArtifactPower)
			
			--local Percent = math.floor( CalcPercent(CurRank +1, CurPow + TotalArtifactPower) * 100)
			--APH:Print("Current",CurPow,"TotalAP",TotalArtifactPower,"Rank",CurRank,CalcPercent(CurRank+1, CurPow+TotalArtifactPower))
			weap.Percent:SetText(Percent.."%")
			if Percent>=100 then
				ActionButton_ShowOverlayGlow(weap)
			else
				ActionButton_HideOverlayGlow(weap)
			end
		else
			weap:SetButtonState("PUSHED",true)
		end
			
		--weap:SetScript("OnEnter", function() APH:ShowTT(j) end)
		--weap:SetScript("OnLeave", function() APH:HideTT() end)

		weap:SetPoint("TOPLEFT",ArtifactInfoFrame,"TOPLEFT",APHdata.WC[nW].OffSet+(40+APHdata.WC[nW].Spacing)*(i-1),-30)
	end
end
--APH:UpdateWeapons()	

function APH:Update()
	ArtPow={}
	APH:GetInventoryItems()
	for _,t in ipairs(APHArtifactItems) do t.Icon:SetTexture(0,0,0,1); t:Hide() end
	local itemsNum=table.getn(ArtPow)
	--APH:Print(itemsNum)
	--local dimW, dimH = 220, 100
	--APHMainFrame:SetSize(dimW, dimH)
	local j=1
	for i, ids in ipairs(ArtPow) do
	--APH:Print("Update:",ids)
		--local button = APH:CreateArtifactItems(ids.id)
		local button = APHArtifactItems[j]
		--APH:Print(button)
		texture = select(10, GetItemInfo(ids[1]) )
		button.Icon:SetTexture(texture)
		button:SetScript("OnEnter", function() APH:ShowTT(ids[1]) end)
		button:SetScript("OnLeave", function() APH:HideTT() end)
		button:SetAttribute("item","item:"..ids[1])
		local col, row = (j-1) - math.floor((j-1)/6)*6, math.floor((j-1)/6)
		button:SetPoint("TOPLEFT", ArtifactPowerFrame,"TOPLEFT", 4+col*36,-90-row*36)
		
		button.Count:SetText(ids[3])
		button.AP:SetText("|c0000ff00"..ReadableNumber(ids[2],2).."|r")
		
		button:Show()
		j=j+1
	end
	if msqGroups["APHItems"] then
		msqGroups.APHItems:ReSkin()
		msqGroups.APHWeapons:ReSkin()
	end
	--APH:Print(i)
	APH:UpdateTotalPower()
	APH:UpdateWeapons()
end



function APH:PLAYER_REGEN_DISABLED()
	self:UnregisterEvent("BAG_UPDATE")
	APHMainFrame:Hide()
end

function APH:PLAYER_REGEN_ENABLED()
	self:RegisterEvent("BAG_UPDATE")
	APHMainFrame:Show()
	--APH:Update()
	--APH:UpdateWeapons()
end

function APH:BAG_UPDATE()
	APH:Update()
end

function APH:PLAYER_ENTERING_WORLD()
	--APH:UpdateWeapons()
	--APH:UpdateWeapons()
	APH:Update()
end

function APH:ARTIFACT_UPDATE()
APH:Update()
end

function APH:StopMoving()
	APHMainFrame:StopMovingOrSizing()
	APH.db.profile.MainPosX = APHMainFrame:GetLeft()
	APH.db.profile.MainPosY = APHMainFrame:GetBottom()
end

APHMainFrame = CreateFrame("Frame", "ArtifactPowerFrame", UIParent)
    APHMainFrame:SetSize(220, 150)
local tex = APHMainFrame:CreateTexture("ARTWORK");
tex:SetAllPoints();
--tex:SetTexture(1.0, 0.5, 0); tex:SetAlpha(0.7);
--tex:SetTexture([[Interface\AddOns\Aph\Ohi_Smoked.tga]])
	APH:Print("On frame Creation",APH.PosX, APH.PosY)
    APHMainFrame:SetPoint("BOTTOMLEFT", UIParent,"BOTTOMLEFT", APH.PosX,APH.PosY)
    APHMainFrame:SetMovable(true)
    APHMainFrame:SetClampedToScreen(true)
	APHMainFrame:SetDontSavePosition(true)
	APHMainFrame:EnableMouse(true)
	APHMainFrame:RegisterForDrag("LeftButton")
	APHMainFrame:SetScript("OnDragStart", APHMainFrame.StartMoving)
	APHMainFrame:SetScript("OnDragStop", function () APH:StopMoving() end)

local APHInfoFrame = CreateFrame("Frame", "ArtifactInfoFrame", ArtifactPowerFrame)
		APHInfoFrame:SetSize(220,40)
		APHInfoFrame:SetPoint("TOPLEFT", ArtifactPowerFrame)
		APHInfoFrame.ItemsAP= APHInfoFrame:CreateFontString("TotalItemsAP","ARTWORK","NumberFontNormal")
		APHInfoFrame.ItemsAP:SetFont("Fonts\\FRIZQT__.TTF", 14)
		APHInfoFrame.ItemsAP:SetJustifyH("CENTER")
		APHInfoFrame.ItemsAP:SetPoint("TOPLEFT")
		APHInfoFrame.ItemsAP:SetPoint("TOPRIGHT")
		--APHInfoFrame.ItemsAP:SetText(ReadableNumber(TotalArtifactPower,2))
	APH:Print("After Creating InfoFrame", TotalArtifactPower)

function APH:UpdateTotalPower()
APHInfoFrame.ItemsAP:SetText(BreakUpLargeNumbers(TotalArtifactPower) .. "/" .. BreakUpLargeNumbers( (CostOfNext or 0) - (CurPow or 0) ) )
end	
	
local APHItemFrame = CreateFrame("Frame", "ArtifactItemFrame", ArtifactPowerFrame)
		APHItemFrame:SetPoint("BOTTOMLEFT", ArtifactInfoFrame,"BOTTOMLEFT",0,0)
	APH:CreateArtifactItems()
	APH:CreateWeaponsIcons()


		

